990001#/*
990002# * Automaton to interpret LALR(1) tables.
990003# *
990004# *	Macros:
990005# *		yyclearin - clear the lookahead token.
990006# *		yyerrok - forgive a pending error
990007# *		YYERROR - simulate an error
990008# *		YYACCEPT - halt and return 0
990009# *		YYABORT - halt and return 1
990010# *		YYRETURN(value) - halt and return value.  You should use this
990011# *			instead of return(value).
990012# *
990013# *	Conditional compilation flags:
990014# *		yydebug - include debug code.  This is both an external
990015# *			and a manifest.  To make the parser print a travelogue
990016# *			arrange that this is the debug output unit (usually 1).
990017# *			Either set the manifest to the I/O unit, or delete
990018# *			the manifest so the code is compiled, and set the
990019# *			external to the debug unit.  Note that if you do this
990020# *			You will need to add extrn statements for
990021# *			yydebug, yysmap, and yyrmap
990022# *		YYSSIZE - size of state and value stacks (default 150).
990023# *		YYSYNC  - Force parser to do 1 token readhead before all
990024# *			reductions.  May have surprising results.
990025# *
990026# *	Copyright (c) 1985,1986 by the University of Waterloo
990027# */
990028#
990029#
990030#YYSSIZE	= 150;
990031#yydebug 0;			/* See above discussion */
990032#yydebug = 0;			/* Default do not compile debug code */
990033#YYSYNC = 0;			/* Default reduce ASAP */
990034#YYERROR		=	goto yyerrlabel;
990035#yyerrok		=	yyerrflag = 0;
990036#yyclearin	=	yychar = -1;
990037#YYACCEPT	=	YYRETURN(0);
990038#YYABORT		=	YYRETURN(1);
990039#YYRETURN	=	return;
990040#YYERRCODE	=	256;			/* value of `error' */
990041# YYTEST = ; yytest = YYTEST; yytest /* need respect case on */
990042#yyval;				/* $$ */
990043#yypvt;				/* $n */
990044#yylval;				/* yylex() sets this */
990045#
990046#yychar;				/* current token */
990047#yyerrflag;			/* error flag */
990048#yynerrs;			/* error count */
990049#
990050#
990051#yyparse() {
990052#
990053#	auto	yyp, yyi;	/* for table lookup */
990054#	auto	yyps;		/* top of state stack */
990055#	auto	yystate;	/* current state */
990056#	auto	yypv;		/* top of value stack */
990057#	auto	yyq;
990058#	auto	yyj;
990059#	extrn 	yynerrs,yyval,yyrlen,yypgo,yypact,yyerrfla,yypvt,yylr2;
990060#	extrn	yyact,yygo,yychar,yyex,yydef,yylval,.null;
990061#	auto 	yyv;
990062#	auto	yys;
$A
990064#	yys = .alloc(YYSSIZE);
990065#	yyv = .alloc(YYSSIZE);
990066#
990067#	yynerrs = 0;
990068#	yyerrflag = 0;
990069#	yychar = -1;
990070#	yyps = &yys[-1];
990071#	yypv = &yyv[-1];
990072#	yystate = YYS0;		/* start state */
990073#
990074#yyStack:
990075#	if (++yyps >= &yys[YYSSIZE]) {
990076#		yyerror("Parser stack overflow");
990077#		YYABORT;
990078#	}
990079#	*yyps = yystate;	/* stack current state */
990080#	*++yypv = yyval;	/* ... and value */
990081#
990082#	if (yydebug)
990083#		.prntf(yydebug, "state %d (%d), char %s (%d)*n", yysmap[yystate],
990084#			yystate, yyptok(yychar), yychar);
990085#
990086#	/*
990087#	 *	Look up next action in action table.
990088#	 */
990089#
990090#yyEncore:
990091#	/* Need a token */
990092#	if (YYSYNC && yychar < 0) {
990093#		if ((yychar = yylex()) < 0)
990094#			yychar = 0;
990095#		if (yydebug)
990096#			.prntf(yydebug, "read %s (%d)*n", yyptok(yychar), yychar);
990097#	}
990098#	if (yystate >= YYNPACT) 	/* simple state */
990099#		yyi = yystate - YYDELTA;	/* reduce in any case */
990100#	else {
990101#		if( *(yyp = &yyact[yypact[yystate]]) >= 0 ) {
990102#			/* Look for a shift on yychar */
990103#			if (!YYSYNC && yychar < 0) {
990104#				if ((yychar = yylex()) < 0)
990105#					yychar = 0;
990106#				if (yydebug)
990107#					.prntf(yydebug, "read %s (%d)*n", yyptok(yychar), yychar);
990108#			}
990109#			yyq = yyp;
990110#			yyi = yychar;
990111#			while (yyi < *yyp++);
990112#			if (yyi == yyp[-1]) {
990113#				yystate = ~yyq[yyq-yyp];
990114#				if (yydebug)
990115#					.prntf(yydebug, "shift %d (%d)*n",
990116#					       yysmap[yystate], yystate);
990117#				yyval = yylval;		/* stack what yylex() set */
990118#				yychar = -1;		/* clear token */
990119#				if (yyerrflag)
990120#					yyerrflag--;	/* successful shift */
990121#				goto yyStack;
990122#			}
990123#		}
990124#	
990125#		/*
990126#	 	*	Fell through - take default action
990127#	 	*/
990128#
990129#		if( yystate >= YYNDEF )
990130#			goto yyError;
990131#		if ((yyi = yydef[yystate]) < 0)	 { /* default == reduce? */
990132#											/* Search exception table */
990133#			yyp = &yyex[~yyi];
990134#			if (!YYSYNC && yychar < 0) {
990135#				if ((yychar = yylex()) < 0)
990136#					yychar = 0;
990137#				if (yydebug)
990138#					.prntf(yydebug, "read %s (%d)*n", yyptok(yychar), yychar);
990139#			}
990140#			while( (yyi = *yyp) >= 0 && yyi != yychar)
990141#				yyp += 2;
990142#			yyi = yyp[1];
990143#		}
990144#	}
990145#
990146#yyReduce:	/* reduce yyi */
990147#	yyj = yyrlen[yyi];
990148#	if (yydebug)
990149#		.prntf(yydebug, "reduce %d (%d), pops %d (%d)*n",
990150#			yyrmap[yyi], yyi, yysmap[yyps[-yyj]], yyps[-yyj]);
990151#	yyps -= yyj;		/* pop stacks */
990152#	yypvt = yypv;		/* save top */
990153#	yypv -= yyj;
990154#	yyval = yypv[1];	/* default action $$ = $1 */
990155#	switch (yyi) {		/* perform semantic action */
$A
990157#	case YYrACCEPT:
990158#		YYACCEPT;
990159#	case YYrERROR:
990160#		goto yyError;
990161#	case YYrLR2:
990162#		if (!YYSYNC && yychar < 0) {
990163#			if ((yychar = yylex()) < 0)
990164#				yychar = 0;
990165#			if (yydebug)
990166#				.prntf(yydebug, "read %s (%d)*n", yyptok(yychar), yychar);
990167#		}
990168#		yyj = 0;
990169#		while( yylr2[yyj] >= 0 ) {
990170#			if( yylr2[yyj] == yystate && yylr2[yyj+1] == yychar
990171#				&& yylook(yys,yyps,yystate,yychar,yy2lex(),yylr2[yyj+2]) )
990172#					break;
990173#			yyj += 3;
990174#		}
990175#		if( yylr2[yyj] < 0 )
990176#			goto yyError;
990177#		if( yylr2[yyj+2] < 0 ) {
990178#			yystate = ~ yylr2[yyj+2];
990179#			goto yyStack;
990180#		}
990181#		yyi = yylr2[yyj+2];
990182#		goto yyReduce;
990183#	}
990184#
990185#	/*
990186#	 *	Look up next state in goto table.
990187#	 */
990188#
990189#	yyp = &yygo[yypgo[yyi]];
990190#	yyq = yyp++;
990191#	yyi = *yyps;
990192#	do
990193#		;
990194#	while (yyi < *yyp++);
990195#	yystate = ~(yyi == *--yyp? yyq[yyq-yyp]: *yyq);
990196#	goto yyStack;
990197#
990198#yyerrlabel:
990199# if( yyi == YYrERROR ) { yyps--; yypv--; }
990200#	yyerrflag = 1;
990201#
990202#yyError:
990203#	switch (yyerrflag) {
990204#
990205#		case 0:		/* new error */
990206#			yynerrs++;
990207#			yyi = yychar;
990208#			yyerror("Syntax error");
990209#			if (yyi != yychar) {
990210#				/* user has changed the current token */
990211#				/* try again */
990212#				yyerrflag++;	/* avoid loops */
990213#				goto yyEncore;
990214#			}
990215#
990216#		case 1:		/* partially recovered */
990217#		case 2:
990218#			yyerrflag = 3;	/* need 3 valid shifts to recover */
990219#			
990220#			/*
990221#			 *	Pop states, looking for a
990222#			 *	shift on `error'.
990223#			 */
990224#
990225#			for ( ; yyps >= yys; yyps--+ yypv--) {
990226#				if (*yyps >= YYNPACT)
990227#					next;
990228#				yyp = &yyact[yypact[*yyps]];
990229#				yyq = yyp;
990230#				while (YYERRCODE < *yyp++);
990231#				if (YYERRCODE == yyp[-1]) {
990232#					yystate = ~yyq[yyq-yyp];
990233#					goto yyStack;
990234#				}
990235#				
990236#				/* no shift in this state */
990237#				if (yydebug && yyps > yys)
990238#					.prntf(yydebug, "Error recovery pops state *
990239#					                 (%d), uncovers %d (%d)*n",
990240#						yysmap[yyps[0]], yyps[0],
990241#						yysmap[yyps[-1]], yyps[-1]);
990242#
990243#				/* pop stacks; try again */
990244#			}
990245#			/* no shift on error - abort */
990246#			break;
990247#
990248#		case 3:
990249#			/*
990250#			 *	Erroneous token after
990251#			 *	an error - discard it.
990252#			 */
990253#
990254#			if (yychar == 0)  /* but not EOF */
990255#				break;
990256#			if (yydebug)
990257#				.prntf(yydebug, "Error recovery discards %s (%d)*n",
990258#					yyptok(yychar), yychar);
990259#			yyclearin;
990260#			goto yyEncore;	/* try again in same state */
990261#	}
990262#	YYABORT;
990263#}
990264#
990265#yylook(s,rsp,state,c1,c2,i)
990266#{
990267#/*	auto	s;								stack				*/
990268#/*	auto	rsp;							real top of stack	*/
990269#/*	auto	state;							current state		*/
990270#/*	auto	c1;								current char		*/
990271#/*	auto	c2;								next char			*/
990272#/*	auto	i;								action S < 0, R >= 0*/
990273#	auto	j;
990274#	auto	p,q;
990275#	auto 	sb,st;
990276#	extrn	yyrlen,yypgo,yypact,yydef,yylr2,yyact,yygo,yyex;
990277#	if (yydebug) {
990278#		.prntf(yydebug, "LR2 state %d (%d) char %s (%d) lookahead %s (%d)",
990279#			yysmap[state],state,yyptok(c1),c1,yyptok(c2),c2);
990280#		if( i > 0 )
990281#			.prntf(yydebug, "reduce %d (%d)*n", yyrmap[i], i);
990282#		else
990283#			.prntf(yydebug, "shift %d (%d)*n", yysmap[i], i);
990284#	}
990285#	st = sb = rsp+1;
990286#	if( i >= 0 ) goto reduce;
990287#  shift:
990288#	state = ~i;
990289#	c1 = c2;
990290#	if( c1 < 0 ) return (1);
990291#	c2 = -1;
990292#
990293#  stack:
990294#  	if( ++st >= &s[YYSSIZE] ) {
990295#		yyerror("Parser Stack Overflow");
990296#		return (0);
990297#	}
990298#	*st = state;
990299#	if( state >= YYNPACT )
990300#		i = state- YYDELTA;
990301#	else {
990302#		p = &yyact[yypact[state]];
990303#		q = p;
990304#		i = c1;
990305#		while( i < *p++ );
990306#		if( i == p[-1] ) {
990307#			state = ~q[q-p];
990308#			c1 = c2;
990309#			if( c1 < 0 ) return (1);
990310#			c2 = -1;
990311#			goto stack;
990312#		}
990313#		if( state >= YYNDEF )
990314#			return (0);
990315#		if( (i = yydef[state]) < 0 ) {
990316#			p = &yyex[~i];
990317#			while( (i = *p) >= 0 && i != c1)
990318#				p += 2;
990319#			i = p[1];
990320#		}
990321#	}
990322#  reduce:
990323#  	j = yyrlen[i];
990324#	if( st-sb >= j )
990325#		st -= j;
990326#	else {
990327#		rsp -= j+st-sb;
990328#		st = sb;
990329#	}
990330#	switch( i ) {
990331#	  case YYrERROR:
990332#		return (0);
990333#	  case YYrACCEPT:
990334#		return (1);
990335#	  case YYrLR2:
990336#		j = 0;
990337#		while( yylr2[j] >= 0 ) {
990338#			if( yylr2[j] == state && yylr2[j+1] == c1 )
990339#				if( (i = yylr2[j+2]) < 0 )
990340#					goto shift;
990341#				else
990342#					goto reduce;
990343#		}
990344#		return (0);
990345#	}
990346#	p = &yygo[yypgo[i]];
990347#	q = p++;
990348#	i = st==sb ? *rsp : *st;
990349#	while( i < *p++ );
990350#	state = ~( i == *--p? q[q-p]: *q);
990351#	goto stack;
990352#}
990353#	
990354#	/*
990355#	 *	Print a token legibly.
990356#	 *	This won't work if you roll your own token numbers,
990357#	 *	but I've found it useful.
990358#	 */
990359#
990360#yyptok(i) {
990361#	auto buf;
990362#	extrn yystoken;
990363#	buf = "static buffer";
990364#	if (i >= YYERRCODE)
990365#		return (yystoken[i-YYERRCODE]);
990366#	if (i < 0)
990367#		return ("");
990368#	if (i == 0)
990369#		return ("$end");
990370#	if (i < ' ')
990371#		.print(buf, "'^%c'", i+'@');
990372#	else
990373#		.print(buf, "'%c'", i);
990374#	return (buf);
990375#}
